#include "validation.h"

int main(int argc, char **argv) {
	// Set up the input and answer streams.
	std::ifstream in(argv[1]);
	std::ifstream ans(argv[2]); // Only for custom checker.
	OutputValidator v(argc, argv);

	// n <= 10^6
	long long n;
	in >> n;

	bool possible;
	{
		string s;
		ans >> s;
		possible = s != "impossible";
	}

	if(possible){
		long long m = v.read_long_long(0, n);
		v.space();
		long long k = v.read_long_long(0, n);
		v.newline();

		if(n != m*m - k*k){
			v.WA("m=",m," and k=", k, " which has m^2-k^2 = ", m*m-k*k, " which does not equal ", n);
		}
	} else {
		v.read_string("impossible");
		v.newline();
	}
}
