#include <iostream>
#include <vector>

using namespace std;

int main() {
	int R, C;
	cin >> R >> C;

	vector<int> eastProposal(R);
	for (int i=0; i<R; i++) cin >> eastProposal[i];
	vector<int> northProposal(C);
	for (int i=0; i<C; i++) cin >> northProposal[i];

	int maxv = 0;
	for (int i=0; i<R; i++) maxv = max(maxv, eastProposal[i]);
	for (int i=0; i<C; i++) maxv = max(maxv, northProposal[i]);

	vector<vector<int>> cityGrid(R,vector<int>(C,0));
	while (true) {
		bool prog = false;
		for (int i=0; i<R && !prog; i++) {
			for (int j=0; j<C && !prog; j++) {
				cityGrid[i][j]++;
				if (cityGrid[i][j] > maxv)
					cityGrid[i][j] = 0;
				else
					prog = true;
			}
		}

		if (!prog)
			break;

		bool ok = true;
		for (int i=0; i<R; i++) {
			int cur=0;
			for (int j=0; j<C; j++) {
				cur = max(cur, cityGrid[i][j]);
			}
			if (cur != eastProposal[i]) ok = false;
		}
		for (int j=0; j<C; j++) {
			int cur=0;
			for (int i=0; i<R; i++) {
				cur = max(cur, cityGrid[i][j]);
			}
			if (cur != northProposal[j]) ok = false;
		}
		
		if (ok) {
			cout << "possible" << endl;
			return 0;
		}
	}
	
	cout << "impossible" << endl;
	return 0;
}
