#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct P { __int128 x,y; };
P operator-(const P&l, const P&r){ return {l.x-r.x, l.y-r.y}; }

__int128 det(P a, P b){ return a.x*b.y - a.y*b.x; }

__int128 det(P a, P b, P c){ return det(b-a, c-a); }

bool operator<(P a, P b) {
	return det(a,b) < 0;
}

int main() {
	int N;
	cin >> N;
	
	vector<P> pts(N);
	for (int i=0; i<N; i++) {
		long long x, y;
		cin >> x >> y;
		pts[i].x = x+2000000000;
		pts[i].y = y+2000000000;
	}
	
	sort(pts.begin(), pts.end());
	
	long long X, Y;
	
	if (N % 2 == 0) {
		X = pts[N/2].x+pts[N/2-1].x-2000000000;
		Y = pts[N/2].y+pts[N/2-1].y-2000000000;
	} else {
		X = pts[N/2].x-2000000000;
		Y = pts[N/2].y-2000000000;
	}

	long long x1 = -2000000000-(Y+2000000000);
	long long y1 = -2000000000+(X+2000000000);
	long long x2 = -2000000000+(Y+2000000000);
	long long y2 = -2000000000-(X+2000000000);

	cout << x1 << " " << y1 << endl;
	cout << x2 << " " << y2 << endl;

	return 0;
}
